import { NextFunction, Request, Response, RequestHandler } from "express";
export interface NamedRoute {
    name: string;
    path: string;
}
export interface ZemiRouteDefinition {
    name: string;
    path: string;
    parameters: Array<string>;
    reverse: (parameterValues: object) => string;
}
export interface ZemiResponse extends Response {
}
export interface ZemiRequest extends Request {
    routeDefinitions: Record<string, ZemiRouteDefinition>;
}
export declare type ZemiRequestHandler = (request: ZemiRequest, response: ZemiResponse, next: NextFunction, routeDef: ZemiRouteDefinition) => void;
export declare enum ZemiMethod {
    GET = "get",
    POST = "post",
    PUT = "put",
    DELETE = "delete",
    OPTIONS = "options"
}
interface ZemiRouteOptions {
    name: string;
    path: string;
    middleware?: Array<RequestHandler>;
    routes?: Array<ZemiRoute>;
}
declare type ZemiMethodIndexableHandlerDefinition = {
    [method in ZemiMethod]?: ZemiRequestHandler;
};
export declare type ZemiRoute = ZemiMethodIndexableHandlerDefinition & ZemiRouteOptions;
export {};
